#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"dSFMT.h"


#define	Number	100
dsfmt_t dsfmt1;				//random number

double rand_gauss( double mu , double sigma ){	//rand : gauss
	double x1 = dsfmt_genrand_close_open(&dsfmt1);
	double x2 = dsfmt_genrand_close_open(&dsfmt1);
	double y  = sigma * ( sqrt(-2 * log(x1) ) * cos( 2*M_PI * x2)) + mu;
	return y;
}


int main( int argc , char *argv[] ){
	
	//Seed of random number
	dsfmt_init_gen_rand(&dsfmt1,1);
	
	//Parameter
	double a = atof(argv[1]);
	double b = atof(argv[2]);
	double c = atof(argv[3]);
	
	//FILE
	FILE *fpw;
	fpw = fopen("data.dat" ,"w" );
	
	int i;
	double *x,*y,*z;
	double sum1 = 0.0 , sum2 = 0.0;
	x = (double *)calloc( Number , sizeof(double) );
	y = (double *)calloc( Number , sizeof(double) );
	z = (double *)calloc( Number , sizeof(double) );
	
	
	for(i=0;i<Number;i++){
		x[i] = 20.0 * dsfmt_genrand_close_open(&dsfmt1) - 10.0 ;
		sum1 += x[i];
		sum2 += pow(x[i],2);
	}
	double ave_x = sum1/Number;
	double std_x = sqrt(sum2/Number - pow(ave_x ,2) );
	
	for(i=0;i<Number;i++){
		x[i] = (x[i] - ave_x ) / std_x;
		y[i] = a * x[i] + rand_gauss(0,1);
		z[i] = b * x[i] + c * y[i] + rand_gauss(0,1);
	}
	
	sum1 = sum2 = 0.0;
	for(i=0;i<Number;i++){
		sum1 += y[i];
		sum2 += pow(y[i],2);
	}
	double ave_y = sum1/Number;
	double std_y = sqrt(sum2/Number - pow(ave_y ,2) );
	
	sum1 = sum2 = 0.0;
	for(i=0;i<Number;i++){
		sum1 += z[i];
		sum2 += pow(z[i],2);
	}
	double ave_z = sum1/Number;
	double std_z = sqrt(sum2/Number - pow(ave_z ,2) );
	
	
	for(i=0;i<Number;i++){
		y[i] = (y[i] - ave_y ) / std_y;
		z[i] = (z[i] - ave_z ) / std_z;
		fprintf(fpw, "%f	%f	%f\n",x[i],y[i],z[i]);
	}
	
	fclose(fpw);
	free(x);
	free(y);
	free(z);
	
	return 0;
}