//y <- x
//z <- x , y

#include<stdio.h>
#include<stdlib.h>
#include<math.h>


#define size 2
#define Number 100


void matrix_multi( double x[size][size] , double y[size][size] , double z[size][size]){
	int i ,j, k;
	
	for(i=0; i<size; i++){
		for(j=0 ; j< size; j++){
			z[i][j] = 0.0;
			for(k=0;k<size ; k++){
				z[i][j] += x[i][k] * y[k][j];
			}
		}
	}
}

int matrix_inv( double x[size][size] , double inv[size][size]){
	double tmp;
	int i,j,pivot;
	double max;
	int max_row;
	
	
	for(i=0;i<size;i++){
		for(j=0;j<size;j++){
			inv[i][j] = (i==j)? 1.0 : 0.0 ;
		}
	}
	
	for( pivot=0 ; pivot<size ; pivot++ ){	//pivot
		
		max = 0.0;
		for(i= pivot ; i<size ; i++ ){
			if( fabs(x[i][pivot]) > max ){
				max = fabs(x[i][pivot]);
				max_row = i;
			}
		}
		if( max == 0.0 ){
			printf("not exist\a\n");
			return -1;
		}
		if( pivot != max_row ){
			for( j=0; j<size ; j++ ){
				tmp = x[pivot][j];
				x[pivot][j] = x[max_row][j];
				x[max_row][j] = tmp;
				
				tmp = inv[pivot][j];
				inv[pivot][j] = inv[max_row][j];
				inv[max_row][j] = tmp;
				
			}
		}
		
		
		
		tmp = 1.0/x[pivot][pivot];
		for(j=0;j<size ; j++){
			x[pivot][j] *= tmp;
			inv[pivot][j] *= tmp;
		}
		
		
		for(i=0;i<size; i++){	//for1
			if( pivot != i ){
				tmp = x[i][pivot];
				for( j = 0 ; j < size ; j ++){
					x[i][j] -= x[pivot][j]*tmp;
					inv[i][j] -= inv[pivot][j]*tmp;
				}
			}
		}	//for1
		
	}	//pivot
	
	for( i=0 ;i<size ; i++){
		for(j=0; j<size ; j++ ){
			if( inv[i][j] > pow(10,5) ){
				printf("incredible\a\n");
				return -1;
			}
		}
	}
	
	
	return 1;
}


double average( double *x ){
	int t;
	double ave=0.0;
	for( t=0 ; t<Number ;t++){
		ave += x[t];
	}
	return (ave/Number);
}

double Variance(double *x , int num){
	double sum_x  = 0.0;
	double sum_xx = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_xx += x[i]*x[i];
	}
	return (sum_xx/num - pow(sum_x/num, 2));
}

double Covariance(double *x , double *y , int num){
	double sum_x  = 0.0;
	double sum_y  = 0.0;
	double sum_xy = 0.0;
	int i;
	for(i=0;i<num;i++){
		sum_x  += x[i];
		sum_y  += y[i];
		sum_xy += x[i] * y[i];
	}
	return ( sum_xy /num - (sum_x/num)*(sum_y/num) );
}




int main( int argc, char *argv[]){
	
	int i,j,t;
	double b_xy , b_xz, b_yz;
	double diff , sigma;
	double t_xy , t_xz, t_yz;
	double S[size][size];
	double inv[size][size];
	double T[size];
	double *x , *y , *z ;
	x = (double *) calloc( Number , sizeof(double) );
	y = (double *) calloc( Number , sizeof(double) );
	z = (double *) calloc( Number , sizeof(double) );
	
	FILE *fpr,*fpw;
	fpr = fopen( "data.dat" , "r" );
	fpw = fopen( "model1.dat" , "w" );
	
	
	double tmp;
	for(t=0 ; t<Number ; t++){
		fscanf(fpr , "%lf	%lf	%lf",&x[t],&y[t],&z[t]);
	}
	
	
	//1. y = b_xy * x
	b_xy = Covariance( x , y , Number )/ Variance( x, Number );
	diff = 0;
	for(t=0; t<Number ; t++){
		diff += pow( y[t] - b_xy * x[t]   ,2.0 );
	}
	sigma = ( diff / (Number -2 ) ) / ( Number * Variance(x , Number ) );
	t_xy = b_xy/sigma;
	
	
	//2. z = b_xz * x + b_yz * y
	S[0][0] = Variance( x , Number );
	S[0][1] = Covariance( x , y , Number );
	S[1][0] = Covariance( x , y , Number );
	S[1][1] = Variance( y , Number );
	T[0] = Covariance( x , z , Number );
	T[1] = Covariance( y , z , Number );
	
	int check = matrix_inv( S, inv);
	
	b_xz = inv[0][0] * T[0] + inv[0][1] * T[1];
	b_yz = inv[1][0] * T[0] + inv[1][1] * T[1];
	
	diff = 0.0;
	for(t=0;t<Number;t++){
		diff += pow( z[t] - b_xz * x[t] - b_yz * y[t] , 2);
	}
	sigma = sqrt( inv[0][0]/Number * diff / (Number - size -1 ));
	t_xz = b_xz / sigma;
	sigma = sqrt( inv[1][1]/Number * diff / (Number - size -1 ));
	t_yz = b_yz / sigma;
	
	
	fprintf(fpw , "b_xy = %f	t_xy = %f\n",b_xy , t_xy );
	fprintf(fpw , "b_xz = %f	t_xz = %f\n",b_xz , t_xz );
	fprintf(fpw , "b_yz = %f	t_yz = %f\n",b_yz , t_yz );
	
	
	fclose(fpr);
	fclose(fpw);
	free(x);
	free(y);
	free(z);
	return 0;
}

